> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://developers.awork.com/apiv1/custom-fields/put-custom-field-definition-by-id/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server. # Updates the specified custom field definition. PUT https://api.awork.com/api/v1/customfielddefinitions/{customFieldDefinitionId} Content-Type: application/json Updates the definition's name, type, or order. Type changes are limited to compatible date and date-time types or select and colored-select types.The user must be an admin or have `project-manage-config:write` permissions. Reference: https://developers.awork.com/apiv1/custom-fields/put-custom-field-definition-by-id ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `customFieldDefinitionId` (string, required) — The id of the custom field definition to update. ### Body (application/json) This endpoint expects a CustomFieldDefinitionPutForm. - `name` (string, required) — The name of the custom field definition. - `type` (enum, required) — The type of the custom field definition. When updating a custom field definition, only the following changes are allowed: 'date' ↔ 'datetime', 'select' ↔ 'coloredSelect'. - Allowed values: `text`, `number`, `date`, `datetime`, `select`, `coloredSelect`, `link`, `boolean`, `user`, `client` - `order` (double, optional, nullable) — The global (workspace-level) order of the custom field definition. Only project custom field definitions have a global order. ## Response ### 200 OK - `id` (string, optional) — The id of the custom field definition. - `name` (string, optional, nullable) — The name of the custom field definition. - `entity` (enum, optional) — The entity the custom field definition can be linked to. - Allowed values: `task`, `project` - `type` (enum, optional) — The type of the custom field definition. - Allowed values: `text`, `number`, `date`, `datetime`, `select`, `coloredSelect`, `link`, `boolean`, `user`, `client` - `createdOn` (string, optional) — The date this entity was created. - `createdBy` (string, optional) — The id of the user who created this entity. - `updatedOn` (string, optional) — The date this entity was last modified. - `updatedBy` (string, optional) — The id of the user who last modified this entity. - `order` (double, optional, nullable) — If it's a project custom field, it's the global order of the custom field definition. Otherwise, it's the order of the custom field definition within a project template or a project. - `isExternal` (boolean, optional) — True if this entity is coming from an external workspace (awork Connect). ## Errors ### 400 Bad Request Error Bad Request - `code` (string, required) — The error code. - `description` (string, required) — The description of the error. - `link` (string, required) — The link to the API documentation page. - `details` (list of string, optional, nullable) — A list of details describing the error. - `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property. - `traceId` (string, optional, nullable) — The request trace id for tracking the request. ### 404 Not Found Error Not Found - `code` (string, required) — The error code. - `description` (string, required) — The description of the error. - `link` (string, required) — The link to the API documentation page. - `details` (list of string, optional, nullable) — A list of details describing the error. - `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property. - `traceId` (string, optional, nullable) — The request trace id for tracking the request. ## Types ### ValidationErrorResponse The validation error response. - `property` (string, optional, nullable) — The name of the property that failed validation. - `message` (string, optional, nullable) — The reason why this property failed validation. ## Examples **Request** ```json { "name": "Ticket-Number", "type": "text" } ``` **Response** ```json { "id": "123e4567-e89b-12d3-a456-426614174000", "name": "Ticket-Number", "entity": "task", "type": "text", "createdOn": "2022-03-10T16:25:09.100Z", "createdBy": "123e4567-e89b-12d3-a456-426614174000", "updatedOn": "2022-03-10T18:55:00.500Z", "updatedBy": "123e4567-e89b-12d3-a456-426614174000", "order": 1, "isExternal": true } ``` **SDK Code** ```python import requests url = "https://api.awork.com/api/v1/customfielddefinitions/customFieldDefinitionId" payload = { "name": "Ticket-Number", "type": "text" } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.put(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.awork.com/api/v1/customfielddefinitions/customFieldDefinitionId'; const options = { method: 'PUT', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"name":"Ticket-Number","type":"text"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.awork.com/api/v1/customfielddefinitions/customFieldDefinitionId" payload := strings.NewReader("{\n \"name\": \"Ticket-Number\",\n \"type\": \"text\"\n}") req, _ := http.NewRequest("PUT", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.awork.com/api/v1/customfielddefinitions/customFieldDefinitionId") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Put.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"Ticket-Number\",\n \"type\": \"text\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.put("https://api.awork.com/api/v1/customfielddefinitions/customFieldDefinitionId") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"name\": \"Ticket-Number\",\n \"type\": \"text\"\n}") .asString(); ``` ```php request('PUT', 'https://api.awork.com/api/v1/customfielddefinitions/customFieldDefinitionId', [ 'body' => '{ "name": "Ticket-Number", "type": "text" }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.awork.com/api/v1/customfielddefinitions/customFieldDefinitionId"); var request = new RestRequest(Method.PUT); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"Ticket-Number\",\n \"type\": \"text\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [ "name": "Ticket-Number", "type": "text" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/customfielddefinitions/customFieldDefinitionId")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PUT" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```